# include <iostream>
# include <algorithm>
# include <vector>
# include <tuple>
using namespace std;

const int MAX=5*1e3;
pair<long long, long long> a[MAX];
vector<pair<int, int>> v[5];
long long ans[5];
int tab[MAX][MAX];
long long br[5];
long long L,n;

void nepresichash(int tp)
{
    int m;
    cin>>m;

    for(int i=1;i<=m;i++)
    {
        cin>>a[i].first>>a[i].second;
    }

    sort(a+1,a+m+1);
    long long last=0;
    long long le=-1;
    for(int i=1;i<=m;i++)
    {
        if(a[i].first>last)
        {
            if(le!=-1) v[tp].push_back({le,last});
            le=a[i].first;
            ans[tp]+=a[i].second-a[i].first+1;
            last=a[i].second;
        }
        else
        {
            if(a[i].second>last) ans[tp]+=a[i].second-last;
            last=max(last,a[i].second);
        }
    }

   if(le!=-1) v[tp].push_back({le,last});
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>L;
    for(int i=1;i<=4;i++)
    {
        nepresichash(i);
    }

    vector<tuple<long long, long long, int>> d;

    for(int tp=1;tp<=4;tp++)
    {
        for(auto p: v[tp])
        {
            //cout<<p.first<<" "<<p.second<<"\n";
            //d.push_back({p.first,p.second,tp});
            if(tp<=2)
            {
                for(int i=1;i<=L;i++)
                {
                    for(int j=p.first;j<=p.second;j++)
                    {
                        tab[i][j]++;
                    }
                }
            }
            else
            {
                for(int i=p.first;i<=p.second;i++)
                {
                    for(int j=1;j<=L;j++)
                    {
                        tab[i][j]++;
                    }
                }
            }

        }
       // cout<<ans[tp]<<"\n";
    }

    //ort(d.begin(),d.end());
    /*
    long long two=0;
    for(int i=1;i<d.size();i++)
    {
        long long l,r,tp1,le,ri,tp2;
        tie(l,r,tp1)=d[i-1];
        tie(le,ri,tp2)=d[i];

       // cout<<l<<" "<<r<<" "<<tp1<<" "<<"\n";
        //cout<<le<<" "<<ri<<" "<<tp2<<"\n";

        if(tp1!=tp2 and le<=r)
        {
            two+=(min(r,ri)-max(le,l)+1);
        }
    }

   // cout<<two<<"\n";

    cout<<(ans[1]+ans[2]-two*2)*L<<" "<<two*L<<" "<<0<<" "<<0<<"\n";
    */

    for(int i=1;i<=L;i++)
    {
        for(int j=1;j<=L;j++)
        {
            for(int k=1;k<=4;k++)
            {
                if(tab[i][j]==k) br[k]++;
            }
        }
    }

    for(int i=1;i<=4;i++) cout<<br[i]<<" ";
    cout<<"\n";
    return 0;
}
/*
5
3
2 3
5 5
3 5
1
3 4
0
0
*/
