# include <iostream>
# include <algorithm>
# include <vector>
using namespace std;

const int MAX=5e5+11,MAXR=1e7+1;
int a[MAX];
vector<int> adj[MAX];
bool vis[MAX];
int n;
int br=0;

void dfs(int curr)
{
    br++;
    vis[curr]=1;
    for(int nxt: adj[curr])
    {
        if(vis[nxt]==0) dfs(nxt);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
    }

    for(int i=1;i<=n;i++)
    {
        for(int j=i+1;j<=n;j++)
        {
            if(__gcd(a[i],a[j])!=1)
            {
                adj[i].push_back(j);
                adj[i].push_back(i);
            }
        }
    }

    int ans=n;
    for(int i=1;i<=n;i++)
    {
        if(vis[i]==0)
        {
            br=0;
            dfs(i);
            ans-=br-1;
        }
    }

    cout<<ans<<"\n";
    return 0;
}
