#include <bits/stdc++.h>
using namespace std;

string s;

bool visited[5001][5001];
int dp[5001][5001];

int BR = 0;

int f(int l, int r) {
    if (l == r + 1) return 0;
    //if (l >= r) return INT_MIN;

    if (visited[l][r] == BR) return dp[l][r];
    visited[l][r] = BR;

    int ans = -10000;

    for (int i = l + 1; i <= r; i += 2) {
        if (s[l] != s[i]) {
            int c = 1 + f(l + 1, i - 1), d = f(i + 1, r);
            if (c >= 0 && d >= 0) ans = max({ans, c, d});
        }
    }

    //cout << "(" << l << ", " << r << ") -> " << ans << endl;
    return dp[l][r] = ans;
}

int slow() {

    cout << f(0, s.size() - 1) << endl;
    return 0;

}

int br[5001], pair_with[5001], paired[5001];

int fast() {

    int n = s.size(), mn = n;

    for (int i = 1; i <= n; i++) {
        if (s[i - 1] == '0') br[i] = br[i - 1] - 1;
        else br[i] = br[i - 1] + 1;
    }

    stack <pair <int, int>> st;

    for (int i = 1; i <= n; i++) {
        if (paired[i]) {
            st.pop();
            continue;
        }

        for (int j = st.empty() ? n : st.top().second; j > i; j--) {
            if (br[i - 1] == br[j] && s[i - 1] != s[j - 1] && (!paired[i]) && (!paired[j])) {
                pair_with[i] = j;
                pair_with[j] = i;
                paired[i] = paired[j] = 1;
                st.push({i, j});
                ///cout << i << ' ' << j << endl;
                break;
            }
        }
    }

    //for (int i = 1; i <= n; i++) {
    //    cout << pair_with[i] << ' ';
    //}

    //cout << endl;
    //return 0;

    int br = 0, mx = 0;

    for (int i = 1; i <= n; i++) {
        if (pair_with[i] > i) br++;
        else br--;

        mx = max(mx, br);
    }

    cout << mx << endl;
    return 0;

}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> s;
    BR++;

    if (s.size() <= 600) slow();
    else fast();
}
