#include<bits/stdc++.h>
using namespace std;

#define endl "\n"
#define out(x) #x << " = " << x << " "

const int INF = 1e9;
const int MAX_N = 5 * 1e3 + 10;

int L;

vector <pair <int, int>> events;
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> L;

    int n; cin >> n;

    for (int i = 0; i < n ; i ++) {
        int l, r;
        cin >> l >> r;
        events.push_back({l, -1});
        events.push_back({r, 1});
    }

    sort(events.begin(), events.end());

    int cnt = 0, started = -1;
    long long answer = 0;
    for (int i = 0; i < events.size(); i ++) {
        int curr = events[i].first;
        int type = events[i].second;

        cnt -= type;

        if (type == -1) { // New Start
            if (started == -1) {
                started = curr;
            }
        }

        if (type == 1) { // End
            if (cnt == 0) {
                answer += curr - started + 1;
                started = -1;
            }
        }
    }


    answer *= (long long) L;
    cout << answer << " 0 0 0" << endl;
    return 0;
}
