#include<bits/stdc++.h>
using namespace std;

#define endl "\n"
#define out(x) #x << " = " << x << " "
#define cerr if(false) cerr
const int INF = 1e9;
const int MAX_N = 5001;

int n;
int a[MAX_N];

string s;

int ending[MAX_N];
int starting[MAX_N];
int prefix1[MAX_N];
int prefix0[MAX_N];
bool check() {
    stack <int> ed;
    for (int i = 0; i < n; i ++) {
        if (ending[i] == -1) continue;

        if (ed.size() > 0) cerr << out(ed.top()) << endl;
        while (ed.size() > 0 && i > ed.top()) {
            ed.pop();
        }

        if (ed.size() > 0 && ending[i] > ed.top()) {
            return false;
        }

        ed.push(ending[i]);
    }

    return true;
}
int realAnswer = 0;

void solve (int ind) {
    if (ind == n) {
        int score = 0;
        int answer = 0;
        for (int i = 0; i < n; i ++) {
            if (ending[i] != -1) score ++;
            if (starting[i] != -1) score --;
            answer = max(answer, score);
        }

        realAnswer = max(answer, realAnswer);
        return;
    }
    if (starting[ind] != -1) {
        solve(ind + 1);
        return;
    }
    for (int i = ind + 1; i < n; i ++) {
        if (starting[i] != -1) break;
        if (ind > 0 && ((prefix0[i] - prefix0[ind - 1] != prefix1[i] - prefix1[ind - 1]) || (prefix0[n] - prefix0[i] != prefix1[n] - prefix1[i]))) continue;
        if (s[i] == '0' && s[ind] == '1') {
            ending[ind] = i;
            starting[i] = ind;
            ending[i] = -1;
            starting[ind] = -1;

            solve (ind + 1);

            ending[ind] = -1;
            starting[i] = -1;
        }
        if (s[i] == '1' && s[ind] == '0') {
            ending[ind] = i;
            starting[i] = ind;
            ending[i] = -1;
            starting[ind] = -1;
            solve (ind + 1);
            ending[ind] = -1;
            starting[i] = -1;
        }
    }
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> s;

    n = s.size();

    for (int i = 0; i < n; i ++) {
        starting[i] = -1;
        if (i == 0) {
            if (s[i] == '0') prefix0[i] = 1;
            if (s[i] == '1') prefix1[i] = 1;
        } else {
            prefix0[i] = prefix0[i - 1] + (s[i] == '0');
            prefix1[i] = prefix1[i - 1] + (s[i] == '1');
        }
    }
    solve(0);

    cout << realAnswer << endl;
    return 0;
}

