#include <bits/stdc++.h>
using namespace std;

const int MAXL = 1e9 + 1;
const int MAXN = 1e5 + 1;
const int START = 0, END = 1;
int L;
vector<tuple<int, int, int>> Line;
vector<tuple<int, int, int>> Column;

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> L;
    int Size; cin >> Size;

    for(int i = 0; i < Size; i++)
    {
        int l, r; cin >> l >> r;
        Line.push_back({l, START, 0});
        Line.push_back({r + 1, END, 0});
    }

    cin >> Size;

    for(int i = 0; i < Size; i++)
    {
        int l, r; cin >> l >> r;
        Line.push_back({l, START, 1});
        Line.push_back({r + 1, END, 1});
    }

    cin >> Size;

    for(int i = 0; i < Size; i++)
    {
        int l, r; cin >> l >> r;
        Column.push_back({l, START, 0});
        Column.push_back({r + 1, END, 0});
    }

    cin >> Size;

    for(int i = 0; i < Size; i++)
    {
        int l, r; cin >> l >> r;
        Column.push_back({l, START, 1});
        Column.push_back({r + 1, END, 1});
    }

    sort(Line.begin(), Line.end());
    sort(Column.begin(), Column.end());
}

void Solve()
{
    int LOne = 0, LTwo = 0, LZero = 0;
    int Current = 0;
    int Last = -1;
    queue<int> North, South;

    for(int i = 0; i < Line.size(); i++)
    {
        if(get<1>(Line[i]) == START)
        {
            int N = 0;

            if(get<2>(Line[i]) == 0)
            {
                North.push(i);
            }
            else
            {
                South.push(i);
            }

            if(!North.empty())
            {
                N++;
            }

            if(!South.empty())
            {
                N++;
            }

            if(Current != N)
            {
                if(Last != -1)
                {
                    if(Current == 1)
                    {
                        LOne += (get<0>(Line[i]) - Last);
                    }
                    else if(Current == 2)
                    {
                        LTwo += (get<0>(Line[i]) - Last);
                    }
                }

                Current = N;
                Last = get<0>(Line[i]);
            }
        }
        else
        {
            int N = 0;

            if(get<2>(Line[i]) == 0)
            {
                North.pop();
            }
            else
            {
                South.pop();
            }

            if(!North.empty())
            {
                N++;
            }

            if(!South.empty())
            {
                N++;
            }

            if(Current != N)
            {
                if(Last != -1)
                {
                    if(Current == 1)
                    {
                        LOne += (get<0>(Line[i]) - Last);
                    }
                    else if(Current == 2)
                    {
                        LTwo += (get<0>(Line[i]) - Last);
                    }
                }

                Current = N;
                Last = get<0>(Line[i]);
            }
        }
    }

    int ROne = 0, RTwo = 0, RZero = 0;
    Current = 0;
    Last = -1;
    queue<int> West, East;

    for(int i = 0; i < Column.size(); i++)
    {
        if(get<1>(Column[i]) == START)
        {
            int N = 0;

            if(get<2>(Column[i]) == 0)
            {
                West.push(i);
            }
            else
            {
                East.push(i);
            }

            if(!West.empty())
            {
                N++;
            }

            if(!East.empty())
            {
                N++;
            }

            if(Current != N)
            {
                if(Last != -1)
                {
                    if(Current == 1)
                    {
                        ROne += (get<0>(Column[i]) - Last);
                    }
                    else if(Current == 2)
                    {
                        RTwo += (get<0>(Column[i]) - Last);
                    }
                }

                Current = N;
                Last = get<0>(Column[i]);
            }
        }
        else
        {
            int N = 0;

            if(get<2>(Column[i]) == 0)
            {
                West.pop();
            }
            else
            {
                East.pop();
            }

            if(!West.empty())
            {
                N++;
            }

            if(!East.empty())
            {
                N++;
            }

            if(Current != N)
            {
                if(Last != -1)
                {
                    if(Current == 1)
                    {
                        ROne += (get<0>(Column[i]) - Last);
                    }
                    else if(Current == 2)
                    {
                        RTwo += (get<0>(Column[i]) - Last);
                    }
                }

                Current = N;
                Last = get<0>(Column[i]);
            }
        }
    }

    LZero = L - (LOne + LTwo);
    RZero = L - (ROne + RTwo);
    long long Total = L * L - (LOne * ROne + LZero * RTwo + RZero * LTwo + LOne * RTwo + LTwo * ROne + RTwo * LTwo);
    cout << Total << " " << LOne * ROne + LZero * RTwo + RZero * LTwo << " " << LOne * RTwo + LTwo * ROne << " " << RTwo * LTwo;
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}
