#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5 * 1e5 + 1;
const int MAXVALUE = 1e7 + 1;
const int MAXSQRT = 1e4 + 1;
int N;
long long A[MAXN];
bool Mark[MAXVALUE];
bool Prime[MAXSQRT];
vector<long long> Primes;
long long Ans = 0;

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Sieve()
{
    Prime[0] = true;
    Prime[1] = true;

    for(int i = 2; i * i < MAXSQRT; i++)
    {
        if(Prime[i])
        {
            continue;
        }

        for(int j = i * i; j < MAXSQRT; j += i)
        {
            Prime[j] = true;
        }
    }

    for(int i = 2; i < MAXSQRT; i++)
    {
        if(!Prime[i])
        {
            Primes.push_back(i);
        }
    }
}

void Read()
{
    cin >> N;
}

void Add(int Value)
{
    long long Cost = 1;

    for(int i = 0; Primes[i] * Primes[i] <= Value; i++)
    {
        if(Value % Primes[i] != 0)
        {
            continue;
        }

        if(Mark[Primes[i]])
        {
            Cost = 0;
        }

        Mark[Primes[i]] = true;

        while(Value % Primes[i] == 0)
        {
            Value /= Primes[i];
        }
    }

    if(Value != 1)
    {
        if(Mark[Value])
        {
            Cost = 0;
        }

        Mark[Value] = true;
    }

    Ans += Cost;
}

void Solve()
{
    for(int i = 0; i < N; i++)
    {
        cin >> A[i];
        Add(A[i]);
    }

    cout << Ans;
}

int main()
{
    FastEJOI();
    Sieve();
    Read();
    Solve();
    return 0;
}

