#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5001;
int N;
int dp[MAXN][MAXN];
bool Visited[MAXN][MAXN];
string S;

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> S;
    N = (int)S.size();
}

int f(int l, int r)
{
    if(l < 0 || r > N)
    {
        return 0;
    }

    if(l >= r)
    {
        return 0;
    }

    if(Visited[l][r])
    {
        return dp[l][r];
    }

    Visited[l][r] = true;

    for(int i = l; i <= r; i++)
    {
        for(int j = i + 1; j <= r; j++)
        {
            if(S[i] != S[j])
            {
                dp[l][r] = max(dp[l][r], f(i + 1, j - 1) + 1);
            }
        }
    }

    return dp[l][r];
}

void Solve()
{
    cout << f(0, N - 1);
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}

