#include <iostream>
#include <algorithm>
using namespace std;
#define pos first.first
#define st first.second
#define dir second

pair<pair<int, bool>, bool> v[400008];///vertical
pair<pair<int, bool>, bool> h[400008];///horizontal
int L, u, d, l, r;
int cols1 = 0, cols2 = 0;

void inVert() {
    cin >> u;
    for (int i = 0; i < u; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        v[2 * i] = make_pair(make_pair(a - 1, 1), 0);
        v[2 * i + 1] = make_pair(make_pair(b, 0), 0);
    }
    cin >> d;
    for (int i = 0; i < d; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        v[2 * i + 2 * u] = make_pair(make_pair(a - 1, 1), 1);
        v[2 * i + 1 + 2 * u] = make_pair(make_pair(b, 0), 1);
    }
}

void calcCols() {
    int lastPos = 0, levelN = 0, levelS = 0;
    for (int i = 0; i < 2 * u + 2 * d; i++) {
        if (levelN > 0 || levelS > 0) {
            if (levelN > 0 && levelS > 0) {
                cols2 += v[i].pos - lastPos;
            } else {
                cols1 += v[i].pos - lastPos;
            }
        }
        if (v[i].st) {
            if (v[i].dir) levelN++;
            else levelS++;
        } else {
            if (v[i].dir) levelN--;
            else levelS--;
        }

        lastPos = v[i].pos;
    }
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> L;
    inVert();
    sort(v, v + 2 * u + 2 * d);
    calcCols();
    int c1 = cols1, c2 = cols2;
    int emptyCols = L - c1 - c2;
    cols1 = 0;
    cols2 = 0;

    inVert();
    sort(v, v + 2 * u + 2 * d);
    calcCols();
    int r1 = cols1, r2 = cols2;
    int emptyRows = L - r1 - r2;

    cout << emptyCols * r1 + c1 * emptyRows << " ";
    cout << emptyCols * r2 + c2 * emptyRows + c1 * r1<< " ";
    cout << c1 * r2 + c2 * r1 << " ";
    cout << c2 * r2;
}
