#include <iostream>
#include <set>
#include <algorithm>
#include <vector>
#include <bitset>
#include <utility>
using namespace std;
#define ll long long

ll prime[670000];
ll a[500001];
bitset<10000001> composite;
ll prFact[670000];
vector<ll>* group[500001];
bitset<500001> merged;


vector<ll> merge(vector<ll> a, vector<ll> b) {
    vector<ll> ans;
    ll j = 0, k = 0;
    while (j < a.size() || k < b.size()) {
        if (j >= a.size() || (k < b.size() && a[j] > b[k])) {
            ans.push_back(b[k++]);
            continue;
        }
        if (k >= b.size() || a[j] < b[k]) {
            ans.push_back(a[j++]);
            continue;
        }
        if (a[j] == b[k]) {
            ans.push_back(a[j++]);
            k++;
        }
    }
    return ans;
}

void factor(ll x, ll idx) {
    if (x == 1) {
        group[idx - 1] = new vector<ll>();
        group[idx - 1]->push_back(1);
        return;
    }
    bool mergedCur = 0;
    vector<ll>* cur = new vector<ll>();
    cur->clear();
    for (ll i = 0; prime[i]/* * prime[i]*/ <= x; i++) {
        int div = prime[i];
        if (x % prime[i] == 0) {
            if (prFact[i] == 0) {
                prFact[i] = idx;
                cur->push_back(prime[i]);
            } else {
                if (mergedCur) {
                    merged[prFact[i] - 1] = 1;
                }
                vector<ll> temp = merge(*group[prFact[i] - 1], *cur);
//                delete group[prFact[i] - 1];
//                delete cur;
//                for (auto j : temp) {
//                    cout << j << " ";
//                }
//                cout << "\n";
                if (mergedCur) {
                    *cur = temp;
                    group[prFact[i] - 1] = cur;
                } else {
                    *group[prFact[i] - 1] = temp;
                    cur = group[prFact[i] - 1];
                    mergedCur = 1;
                }
//                cout << "adsfasdf";
            }
        }
    }
//    cout << "asdadsf>>>";
    merged[idx - 1] = mergedCur;
    group[idx - 1] = cur;
//    cout << "asdadsf????????????????";
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll cnt = 0;
    for (ll i = 2; i * i< 10000000; i++) {
        if (!composite[i]) {
            prime[cnt] = i;
            cnt++;
            for (ll j = i * i; j < 10000000; j += i) {
                composite[j] = 1;
            }
        }
    }

    ll n;
    cin >> n;
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        group[i] = new vector<ll>();
        factor(a[i], i + 1);
    }
//    cout << "??????";
//    for (ll i = 0; i < n; i++) {
//        cout << i << ": ";
//        for (ll j = 0; j < group[i]->size(); j++) {
//            cout << (*group[i])[j] << " ";
//        }
//        cout << "\n";
//    }

    sort(group, group + n);
    cnt = 0;
    for (ll i = 0; i < n; i++) {
        if (i != n - 1 && group[i] == group[i + 1]) {
//            for (auto j : *group[i]) {
//                cout << j << " ";
//            }
//            cout << "\n";
            continue;
        }
        cnt++;
    }
    cout << cnt;
}
