#include <iostream>
#include <algorithm>
using namespace std;
#define val first
#define idx second

char a[5001];
pair<int, int> sum[5001];
int n;
int maxL = 0;

int bin_search(int x, int maxIdx) {
    int l = -1, r = n;
    while (l + 1 < r) {
        int m = l + r;
        if (sum[m].val == x) {
            if (sum[m].idx <= maxIdx) {
                l = m;
            } else {
                r = m;
            }
            continue;
        }
        if (x < sum[m].val) {
            r = m;
        } else {
            l = m;
        }
    }
    return r;
}

void rec(int l, int r, int level, int prefSum) {
    if (l < 0 || r >= n || l >= r) {
        maxL = max(maxL, level);
        return;
    }
    int res = bin_search(prefSum, r) - 1;
    while (a[sum[res].idx] == a[l]) {
        res--;
    }
    if (sum[res].val != prefSum) {
        res = bin_search(prefSum + (a[l] == '0' ? 1 : -1), r) - 1;
    }
    while (a[sum[res].idx] == a[l]) {
        res--;
    }
//    cout << prefSum << " " << res << " " << sum[res].idx << "\n";
    if (res < 0 || res >= n || sum[res].idx > r || sum[res].idx < l) {
        maxL = max(maxL, level);
        return;
    }
    rec(l + 1, sum[res].idx - 1, level + 1, prefSum + (a[l] == '1' ? 1 : -1));
    rec(sum[res].idx + 1, r, level, prefSum);
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> a;
    int curSum = 0;
    for (n = 0; a[n]; n++) {
        if (a[n] == '1') {
            curSum++;
        } else {
            curSum--;
        }
        sum[n] = make_pair(curSum, n);
    }
    sort(sum, sum + n);
    rec(0, n - 1, 0, 0);
    cout << maxL;
}
