#include <iostream>
#include <algorithm>
using namespace std;
#define ll long long
#define val first
#define idx second

char a[5001];
pair<ll, ll> sum[5001];
ll n;
ll maxL = 0;

ll bin_search(ll x, ll maxIdx) {
    ll l = -1, r = n;
    while (l + 1 < r) {
        ll m = l + r;
        if (sum[m].val == x) {
            if (sum[m].idx <= maxIdx) {
                l = m;
            } else {
                r = m;
            }
            continue;
        }
        if (x < sum[m].val) {
            r = m;
        } else {
            l = m;
        }
    }
    return r;
}

void rec(ll l, ll r, ll level, ll prefSum) {
    if (l < 0 || r >= n || l >= r) {
        maxL = max(maxL, level);
        return;
    }
    ll res = bin_search(prefSum, r) - 1;
    while (a[sum[res].idx] == a[l]) {
        res--;
    }
    if (sum[res].val != prefSum) {
        res = bin_search(prefSum + (a[l] == '0' ? 1 : -1), r) - 1;
        while (a[sum[res].idx] == a[l]) {
            res--;
        }
    }
//    cout << prefSum << " " << res << " " << sum[res].idx << "\n";
    if (sum[res].idx > r || sum[res].idx < l) {
        maxL = max(maxL, level);
        return;
    }
    rec(l + 1, sum[res].idx - 1, level + 1, prefSum + (a[l] == '1' ? 1 : -1));
    rec(sum[res].idx + 1, r, level, prefSum);
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> a;
    ll curSum = 0;
    for (n = 0; a[n]; n++) {
        if (a[n] == '1') {
            curSum++;
        } else {
            curSum--;
        }
        sum[n] = make_pair(curSum, n);
    }
    if (sum[n - 1].val != 0) {
        cout << 1 / 0;
    }
    sort(sum, sum + n);
    curSum = 0;
    for (int i = 0; i < n; i++) {
        if (curSum == 0) {
            rec(0, i - 1, 0, 0);
            rec(i, n, 0, 0);
        }
        if (a[i] == '1') {
            curSum++;
        } else {
            curSum--;
        }
    }
    cout << maxL;
}
