#include<bits/stdc++.h>
#define endl "\n"
using namespace std;

const long long MAX=(5e5)+5;

long long a[MAX],p[MAX],r[MAX],n;

void Sol1()
{
    unordered_set<long long>s;
    for(long long i=1;i<=n;i++)
    {
        s.insert(a[i]);
    }
    cout<<s.size()<<endl;
}

long long FindL(long long i)
{
    if(p[i]==i)
        return i;
    return p[i]=FindL(p[i]);
}

void Connect(long long i,long long j)
{
    i=FindL(i);
    j=FindL(j);
    if(i==j)
        return;
    if(r[i]<r[j])
        swap(i,j);
    p[j]=i;
    r[i]+=r[j];
}


bool IsPrime(int x)
{
    if(x==1)
        return 0;
    for(int i=2;i*i<=x;i++)
    {
        if(x%i==0)
            return 0;
    }
    return 1;
}

void Solve()
{
    cin>>n;
    bool b=1;
    for(long long i=1;i<=n;i++)
    {
        cin>>a[i];
        p[i]=i;
        r[i]=1;
    }
    if(n>(1e4))
    {
        Sol1();
        return;
    }
    for(long long i=1;i<=n;i++)
    {
        for(long long j=i+1;j<=n;j++)
        {
            if(__gcd(a[i],a[j])!=1)
                Connect(i,j);
        }
    }
    long long ans=0;
    for(long long i=1;i<=n;i++)
    {
        if(p[i]==i)
            ans++;
    }
    cout<<ans<<endl;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    Solve();
    return 0;
}
