#include<iostream>
using namespace std;
const long long MAXAI=1e7;
void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}
pair<bool, long long>br[MAXAI+2];
long long sito[MAXAI+2];

long long n;
long long a[500'001];


struct VER
{
    long long par;
};

VER arr[1'000'000];

void input()
{
    cin>>n;
    for (long long i=0; i<n; i++)
    {
        cin>>a[i];
    }
}

void makesito()
{
    for (long long i=2; i<MAXAI; i++)
    {
        if (sito[i]!=0) continue;
        sito[i]=i;
        for (long long j=i*i; j<=MAXAI; j+=i)
        {
            if (sito[j]==0) sito[j]=i;
        }
    }
}

void zap()
{
    for (long long i=0; i<n; i++)
    {
        arr[i].par=i;
    }
}

void solve2(long long ind)
{
    long long x=a[ind];

    while (x!=1)
    {
        bool lamp=false;
        long long prev=sito[x];
        while (sito[x]==prev && x!=1)
        {
            x=x/sito[x];
            lamp=true;
        }

        if (br[prev].first==false)
        {
            br[prev].first=true;
            br[prev].second=ind;
        }
        else
        {
            long long par1=ind, par2=br[prev].second;
            while (par1!=arr[par1].par)
            {
                par1=arr[par1].par;
            }
            while (par2!=arr[par2].par)
            {
                par2=arr[par2].par;
            }

            arr[par1].par=par2;
        }
    }
}

void solve()
{
    makesito();
    zap();
    for (long long i=0; i<n; i++)
    {
        //cout<<"bellingham"<<endl;
        solve2(i);

    }
    long long ans=0;
    for (long long i=0; i<n; i++)
    {
        if (arr[i].par==i) ans++;
    }
    cout<<ans<<endl;
}

int main ()
{
    fastIO();
    input();
    solve();
    //if (a.size()<=500) while (true){};
    return 0;
}

