#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const ll MAXL = 5e3 + 10;

vector<vector<ll>>active;
vector<vector<ll>>cur;
ll ans[4];
vector<pair<ll,ll>>v[4];

ll l,n;
ll c[4];

void read()
{
    cin >> l;
    for(int i = 0; i < 4; i++)
    {
        cin >> c[i];
        for(int j = 1; j <= c[i]; j++)
        {
            ll x,y;
            cin >> x >> y;
            v[i].push_back({x,y});
        }
    }
}

void fill_active()
{
    active.resize(l + 2);
    cur.resize(l + 2);
    for(int i = 0; i <= l + 1; i++)
    {
        active[i].resize(4, 0);
        cur[i].resize(4, 0);
    }

    for(int i = 0; i < 4; i++)
    {
        for(ll j = 0; j < c[i]; j++)
        {
            ll x = v[i][j].first;
            ll y = v[i][j].second;
            cur[x][i]++;
            cur[y + 1][i]--;
        }
    }

    for(int i = 1; i <= l; i++)
    {
        active[i][0] = active[i - 1][0] + cur[i][0];
        active[i][1] = active[i - 1][1] + cur[i][1];
        active[i][2] = active[i - 1][2] + cur[i][2];
        active[i][3] = active[i - 1][3] + cur[i][3];
    }

    /**
    for(int i = 1; i <= l; i++)
    {
        for(int j = 0; j < 4; j++)
        {
            cout << active[i][j] << " ";
        }
        cout << endl;
    }
    */
}

void solve()
{
    for(int i = 1; i <= l; i++)
    {
        for(int j = 1; j <= l; j++)
        {
            ll cntN = active[j][0];
            ll cntS = active[j][1];
            ll cntE = active[i][2];
            ll cntW = active[i][3];

            ll cnt = 0;
            if(cntN > 0)
                cnt++;
            if(cntS > 0)
                cnt++;
            if(cntE > 0)
                cnt++;
            if(cntW > 0)
                cnt++;

            if(cnt == 0)
                continue;

            ans[cnt - 1] ++;
        }
    }
    cout << ans[0] << " " << ans[1] << " " << ans[2] << " " << ans[3] << endl;
}

void solve_test3()
{
    sort(v[0].begin(), v[0].end());
    /**
    for(int i = 0; i < c[0]; i++)
    {
        cout << v[0][i].first << " " << v[0][i].second << endl;
    }
    */
    pair<ll,ll> cur = v[0][0];

    for(int i = 1; i < c[0]; i++)
    {
        if(v[0][i].first == cur.first)
        {
            cur = v[0][i];
        }
        else if(v[0][i].second >= cur.second && v[0][i].first <= cur.second)
        {
            cur.second = v[0][i].second;
        }
        else
        {
            ans[0] += (cur.second - cur.first + 1);
            cur = v[0][i];
        }
    }
    ans[0] += (cur.second - cur.first + 1);

    cout << ans[0] << " " << ans[1] << " " << ans[2] << " " << ans[3] << endl;
}

void solve_test4()
{

}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    if(c[1] == 0 && c[2] == 0 && c[3] == 0)
    {
        if(c[0] == 0)
        {
            cout << "0 0 0 0" << endl;
            return 0;
        }
        solve_test3();
    }
    else if(c[2] == 0 && c[3] == 0)
    {
        solve_test4();
    }
    else
    {
        fill_active();
        solve();
    }


    return 0;
}
