#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const ll MAXN = 5e3 + 10;

ll dp[MAXN][MAXN];

ll pref[MAXN][2];
ll n;
ll nxt[MAXN];
bool a[MAXN];
bool is_left[MAXN];
bool used[MAXN];
string s;

void read()
{
    cin >> s;
    n = s.size();
    if(n <= 30)
        assert(false);
}

void make()
{
    for(int i = 0; i < n; i++)
    {
        a[i + 1] = s[i] - '0';
    }
}

void fill_pref()
{
    for(int i = 1; i <= n; i++)
    {
        pref[i][0] = pref[i - 1][0];
        pref[i][1] = pref[i - 1][1];

        pref[i][a[i]]++;
    }
}

bool check(ll left, ll right)
{
    ll zeroes = pref[right][0] - pref[left - 1][0];
    ll ones = pref[right][1] - pref[left - 1][1];

    return zeroes == ones;
}

void fill_nxt()
{
    for(int i = 1; i <= n; i++)
    {
        for(int j = n; j > i; j--)
        {
            if(a[i] == a[j] || used[j])
                continue;

            if(check(i + 1, j - 1))
            {
                is_left[i] = true;
                used[i] = true;
                used[j] = true;
                break;
            }
        }
    }

}

void solve()
{
    ll ans = 0;
    ll active = 0;
    for(int i = 1; i <= n; i++)
    {
        if(is_left[i])
            active++;
        else
            active--;

        ans = max(ans, active);
    }
    cout << ans << endl;
}

ll f(ll left, ll right)
{
    if(left >= right)
        return 0;

    if(dp[left][right] != -1)
        return dp[left][right];

    dp[left][right] = 0;
    for(ll cut = left + 1; cut <= right; cut++)
    {
        if(a[left] == a[cut])
            continue;

        ll cur = max(1 + f(left + 1, cut - 1), f(cut + 1, right));
        dp[left][right] = max(dp[left][right], cur);
    }
    return dp[left][right];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    ///make();
    ///fill_pref();
    ///fill_nxt();
    ///solve();

    ///memset(dp, -1, sizeof(dp));
    ///cout << f(1, n) << endl;
    return 0;
}
