# include <iostream>
using namespace std;

const int MAX=5001;
int a[MAX];
int dp[MAX][MAX];
bool vis[MAX][MAX];
int n;

int solve(int l, int r)
{
    //cout<<l<<" "<<r<<"\n";

    if(l==r+1) return 0;
    if(l+1==r)
    {
        if(a[l]!=a[r]) return 1;
        return -1;
    }
    if(vis[l][r]) return dp[l][r];

    int ans=0;
    vis[l][r]=1;
    if(a[l]!=a[r])
    {
        int x=solve(l+1,r-1);
        if(x!=-1) ans=x+1;
        dp[l][r]=ans;
        return ans;
    }

    for(int i=l+1;i<r;i++)
    {
        //cout<<l<<" "<<i<<";"<<i+1<<" "<<r<<"\n";
        //cout<<a[l]<<" "<<a[i]<<"\n";
        if((i-l+1)%2==0 and (r-i-1+1)%2==0 and a[l]!=a[i])
        {
            //cout<<l<<" "<<r<<":"<<"->"<<i<<"\n";
            int x=solve(l+1,i-1),y=solve(i+1,r);
            if(x!=-1 and y!=-1)
            {
                ans=max(ans,x+1);
                ans=max(ans,y);
            }
        }
    }

    if(a[l]!=a[r])
    {
        int x=solve(l+1,r-1);
        if(x!=-1) ans=max(ans,x+1);
    }

    dp[l][r]=ans;
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    string s;
    cin>>s;

    n=s.size();
    for(int i=0;i<n;i++) a[i+1]=s[i]-'0';

    cout<<solve(1,n)<<"\n";
    return 0;
}
