#include <bits/stdc++.h>
using namespace std;

vector <pair <int, int>> n, e, s, w;

vector <pair <int, int>> horizontal, vertical, vertical_or, horizontal_or;
vector <pair <int, int>> horizontal_xor, vertical_xor, horizontal_and, vertical_and;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int l;
    cin >> l;
    vector <pair <int, int>> v(500001);

    int N, E, S, W;

    cin >> N;
    for (int i = 0; i < N; i++) cin >> v[i].first >> v[i].second;
    sort(v.begin(), v.begin() + N);

    for (int i = 0; i < N; i++) {
        if (n.empty()) {
            n.push_back(v[i]);
            continue;
        }

        if (v[i].first - 1 <= n.back().second) n.back().second = max(n.back().second, v[i].second);
        else n.push_back(v[i]);
    }

    cin >> S;
    for (int i = 0; i < S; i++) cin >> v[i].first >> v[i].second;
    sort(v.begin(), v.begin() + S);

    for (int i = 0; i < S; i++) {
        if (s.empty()) {
            s.push_back(v[i]);
            continue;
        }

        if (v[i].first - 1 <= s.back().second) s.back().second = max(s.back().second, v[i].second);
        else s.push_back(v[i]);
    }

    cin >> E;
    for (int i = 0; i < E; i++) cin >> v[i].first >> v[i].second;
    sort(v.begin(), v.begin() + E);

    for (int i = 0; i < E; i++) {
        if (e.empty()) {
            e.push_back(v[i]);
            continue;
        }

        if (v[i].first - 1 <= e.back().second) e.back().second = max(e.back().second, v[i].second);
        else e.push_back(v[i]);
    }

    cin >> W;
    for (int i = 0; i < W; i++) cin >> v[i].first >> v[i].second;
    sort(v.begin(), v.begin() + W);

    for (int i = 0; i < W; i++) {
        if (w.empty()) {
            w.push_back(v[i]);
            continue;
        }

        if (v[i].first - 1 <= w.back().second) w.back().second = max(w.back().second, v[i].second);
        else w.push_back(v[i]);
    }

    for (auto p : n) horizontal.push_back(p);
    for (auto p : s) horizontal.push_back(p);
    for (auto p : e) vertical.push_back(p);
    for (auto p : w) vertical.push_back(p);


    sort(horizontal.begin(), horizontal.end());
    sort(vertical.begin(), vertical.end());

    for (int i = 0; i < horizontal.size(); i++) {
        if (horizontal_or.empty()) {
            horizontal_or.push_back(horizontal[i]);
            continue;
        }

        if (horizontal[i].first - 1 <= horizontal_or.back().second) horizontal_or.back().second = max(horizontal_or.back().second, horizontal[i].second);
        else horizontal_or.push_back(horizontal[i]);
    }

    for (int i = 0; i < vertical.size(); i++) {
        if (vertical_or.empty()) {
            vertical_or.push_back(vertical[i]);
            continue;
        }

        if (vertical[i].first - 1 <= vertical_or.back().second) vertical_or.back().second = max(vertical_or.back().second, vertical[i].second);
        else vertical_or.push_back(vertical[i]);
    }

    long long VERTICAL_OR_SIZE = 0, HORIZONTAL_OR_SIZE = 0;

    for (auto p : vertical_or) {
        VERTICAL_OR_SIZE += p.second - p.first + 1;
    }

    for (auto p : horizontal_or) {
        HORIZONTAL_OR_SIZE += p.second - p.first + 1;
    }

    //cout << VERTICAL_OR_SIZE << ' ' << HORIZONTAL_OR_SIZE << endl;
    long long VERTICAL_NOR_SIZE = l - VERTICAL_OR_SIZE, HORIZONTAL_NOR_SIZE = l - HORIZONTAL_OR_SIZE;

    for (auto p : horizontal) {
        if (horizontal_xor.empty()) {
            horizontal_xor.push_back(p);
            continue;
        }

        if (p.first <= horizontal_xor.back().second) {
            pair <int, int> seconds = {horizontal_xor.back().second, p.second};
            if (seconds.first > seconds.second) swap(seconds.first, seconds.second);
            pair <int, int> intersection = {p.first, seconds.first};

            horizontal_and.push_back(intersection);
            horizontal_xor.back().second = p.first - 1;

            if (seconds.first + 1 <= seconds.second) horizontal_xor.push_back({seconds.first + 1, seconds.second});
        } else horizontal_xor.push_back(p);
    }

    for (auto p : vertical) {
        if (vertical_xor.empty()) {
            vertical_xor.push_back(p);
            continue;
        }

        if (p.first <= vertical_xor.back().second) {
            pair <int, int> seconds = {vertical_xor.back().second, p.second};
            if (seconds.first > seconds.second) swap(seconds.first, seconds.second);
            pair <int, int> intersection = {p.first, seconds.first};

            vertical_and.push_back(intersection);
            vertical_xor.back().second = p.first - 1;

            if (seconds.first + 1 <= seconds.second) vertical_xor.push_back({seconds.first + 1, seconds.second});
        } else vertical_xor.push_back(p);
    }

    long long HORIZONTAL_XOR_SIZE = 0, VERTICAL_XOR_SIZE = 0;
    long long HORIZONTAL_AND_SIZE = 0, VERTICAL_AND_SIZE = 0;

    for (auto p : horizontal_and) {
        HORIZONTAL_AND_SIZE += p.second - p.first + 1;
    }

    for (auto p : horizontal_xor) {
        HORIZONTAL_XOR_SIZE += p.second - p.first + 1;
    }

    for (auto p : vertical_and) {
        VERTICAL_AND_SIZE += p.second - p.first + 1;
    }

    for (auto p : vertical_xor) {
        VERTICAL_XOR_SIZE += p.second - p.first + 1;
    }

    //cout << endl;
    //cout << VERTICAL_XOR_SIZE << ' ' << VERTICAL_AND_SIZE << ' ' << VERTICAL_NOR_SIZE << endl;
    //cout << HORIZONTAL_XOR_SIZE << ' ' << HORIZONTAL_AND_SIZE << ' ' << HORIZONTAL_NOR_SIZE << endl;
    //cout << endl;

    long long ans1 = VERTICAL_NOR_SIZE * HORIZONTAL_XOR_SIZE + HORIZONTAL_NOR_SIZE * VERTICAL_XOR_SIZE;
    long long ans2 = VERTICAL_NOR_SIZE * HORIZONTAL_AND_SIZE + HORIZONTAL_NOR_SIZE * VERTICAL_AND_SIZE + VERTICAL_XOR_SIZE * HORIZONTAL_XOR_SIZE;
    long long ans3 = VERTICAL_AND_SIZE * HORIZONTAL_XOR_SIZE + HORIZONTAL_AND_SIZE * VERTICAL_XOR_SIZE;
    long long ans4 = VERTICAL_AND_SIZE * HORIZONTAL_AND_SIZE;

    cout << ans1 << ' ' << ans2 << ' ' << ans3 << ' ' << ans4 << endl;
    return 0;

}
/// 10 5 1 3 3 4 6 6 7 8 8 10
