#include <bits/stdc++.h>
using namespace std;

int sieve[10000001], v[500001], a[500001];

vector <int> divisors[10000001];

void insert(int idx) {
    int n = v[idx], new_n = 1;

    while (n != 1) {
        int d = sieve[n];
        new_n *= d;

        while (n % d == 0) n /= d;
        divisors[d].push_back(idx);
    }

    v[idx] = new_n;
}

int total_br;

int root(int u) {
    if (a[u] == u) return u;
    return a[u] = root(a[u]);
}

void connect(int u, int v) {
    if (root(u) == root(v)) return;
    total_br--;

    a[root(u)] = root(v);
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, mx = 0;
    cin >> n;
    total_br = n;

    for (int i = 0; i < n; i++) {
        cin >> v[i];
        mx = max(mx, v[i]);
        a[i] = i;
    }

    for (int i = 2; i <= mx; i++) {
        if (sieve[i]) continue;

        for (int j = i; j <= mx; j += i) {
            if (sieve[j] == 0) sieve[j] = i;
        }
    }


    for (int i = 0; i < n; i++) {
        insert(i);
    }

    for (int i = 2; i <= mx; i++) {
        if (divisors[i].size()) {
            for (int j = 0; j + 1 < divisors[i].size(); j++) {
                connect(divisors[i][j], divisors[i][j + 1]);
            }
        }
    }

    cout << total_br << endl;
    return 0;

}

