#include<bits/stdc++.h>
using namespace std;

#define endl "\n"
#define out(x) #x << " = " << x << " "

const int INF = 1e9;
const int MAX_N = 5 * 1e3 + 10;

int L;

vector <pair <int, pair<int, int>>> events;
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> L;

    int n; cin >> n;

    for (int i = 0; i < n ; i ++) {
        int l, r;
        cin >> l >> r;
        events.push_back({l, {-1, 0}});
        events.push_back({r, {1, 0}});
    }

    cin >> n;

    for (int i = 0; i < n ; i ++) {
        int l, r;
        cin >> l >> r;
        events.push_back({l, {-1, 1}});
        events.push_back({r, {1, 1}});
    }

    sort(events.begin(), events.end());

    int cntA = 0, startedA = -1;
    int cntB = 0, startedB = -1;
    long long answer1 = 0, answer2 = 0;
    for (int i = 0; i < events.size(); i ++) {
        int curr = events[i].first;
        int type = events[i].second.first;
        int dir = events[i].second.second;

        if (dir == 0) cntA -= type;
        if (dir == 1) cntB -= type;

        if (type == -1) { // New Start
            if (dir == 0) {
                if (startedA == -1) {
                    startedA = curr;
                }
            }
            if (dir == 1) {
                if (startedB == -1) {
                    startedB = curr;
                }
            }
        }

        if (type == 1) { // End
            if (dir == 0) {
                if (cntA == 0) {
                    if (cntB == 0) {
                        answer1 += curr - startedA + 1;
                        startedA = -1;
                    } else {
                        answer2 += curr - startedA + 1;
                        startedB = curr + 1;
                    }
                }
            }
            if (dir == 1) {
                if (cntB == 0) {
                    if (cntA == 0) {
                        answer1 += curr - startedB + 1;
                        startedB = -1;
                    } else {
                        answer2 += curr - startedB + 1;
                        startedA = curr + 1;
                    }
                }
            }

        }
    }


    answer1 *= (long long) L;
    answer2 *= (long long) L;
    cout << answer1  << " " << answer2 << " 0 0" << endl;
    return 0;
}
