#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5001;
int N;
int dp[MAXN][MAXN];
bool Visited[MAXN][MAXN];
string S;

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> S;
    N = (int)S.size();
}

int f(int l, int r)
{
    if(l < 0 || r >= N)
    {
        return 0;
    }

    if(l >= r)
    {
        return 0;
    }

    if(Visited[l][r])
    {
        return dp[l][r];
    }

    if(S[l] != S[r])
    {
        dp[l][r] = f(l + 1, r - 1) + 1;
    }
    else
    {
        int Zero = 0, One = 0;
        int i = l, j = r;

        for(i; i <= r; i++)
        {
            if(S[i] == '0')
            {
                Zero++;
            }
            else
            {
                One++;
            }

            if(Zero == One)
            {
                break;
            }
        }

        Zero = 0;
        One = 0;

        for(j; j >= l; j--)
        {
            if(S[j] == '0')
            {
                Zero++;
            }
            else
            {
                One++;
            }

            if(Zero == One)
            {
                break;
            }
        }

        dp[l][r] = max(max(f(l, i), dp[l][r]), max(f(j, r), f(i + 1, j - 1)));
    }

    return dp[l][r];
}

void Solve()
{
    cout << f(0, N - 1);
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}

