#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5001;
int N;
long long dp[MAXN][MAXN];
long long Prefix[MAXN][2];
bool Visited[MAXN][MAXN];
string S;

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> S;
    N = (int)S.size();

    for(int i = 0; i < S.size(); i++)
    {
        if(i != 0)
        {
            Prefix[i][0] = Prefix[i - 1][0];
            Prefix[i][1] = Prefix[i - 1][1];
        }
        if(S[i] == '0')
        {
            Prefix[i][0]++;
        }
        else
        {
            Prefix[i][1]++;
        }
    }
}

long long f(int l, int r)
{
    if(l < 0 || r >= N)
    {
        return 0;
    }

    if(l >= r)
    {
        return 0;
    }

    if(Visited[l][r])
    {
        return dp[l][r];
    }

    if(S[l] == S[r])
    {
        dp[l][r] = f(l + 1, r - 1) + 1;
    }
    else
    {
        Visited[l][r] = true;

        for(int i = l; i <= r; i++)
        {
            for(int j = r; j > i; j--)
            {
                if(S[i] != S[j] && Prefix[i - 1][0] - Prefix[l - 1][0] == Prefix[i - 1][1] - Prefix[l - 1][1] && Prefix[r][0] - Prefix[j][0] == Prefix[r][1] - Prefix[j][1])
                {
                    dp[l][r] = max(dp[l][r], f(i + 1, j - 1) + 1);
                    break;
                }
            }
        }
    }

    return dp[l][r];
}

void Solve()
{
    cout << f(0, N - 1);
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}
