#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5001;
int N;
long long dp[MAXN][MAXN];
long long Prefix[MAXN][2];
bool Visited[MAXN][MAXN];
string S;
vector<int> One;
vector<int> Zero;

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> S;
    N = (int)S.size();

    for(int i = 0; i < S.size(); i++)
    {
        if(i != 0)
        {
            Prefix[i][0] = Prefix[i - 1][0];
            Prefix[i][1] = Prefix[i - 1][1];
        }
        if(S[i] == '0')
        {
            Prefix[i][0]++;
            Zero.push_back(i);
        }
        else
        {
            Prefix[i][1]++;
            One.push_back(i);
        }
    }
}

int Binary_One(int Index)
{
    int l = 0, r = Zero.size() - 1;
    int mid;
    int ans = -1;

    while(l <= r)
    {
        mid = (l + r) / 2;

        if(Zero[mid] <= Index)
        {
            ans = mid;
            l = mid + 1;
        }
        else
        {
            r = mid - 1;
        }
    }

    return ans;
}

int Binary_Zero(int Index)
{
    int l = 0, r = One.size() - 1;
    int mid;
    int ans = -1;

    while(l <= r)
    {
        mid = (l + r) / 2;

        if(One[mid] <= Index)
        {
            ans = mid;
            l = mid + 1;
        }
        else
        {
            r = mid - 1;
        }
    }

    return ans;
}

long long f(int l, int r)
{
    if(l < 0 || r >= N)
    {
        return 0;
    }

    if(l >= r)
    {
        return 0;
    }

    if(Visited[l][r])
    {
        return dp[l][r];
    }

    Visited[l][r] = true;

    for(int i = l; i <= r; i++)
    {
        int R = 0;

        if(S[i] == '0')
        {
            R = Binary_Zero(r);

            if(R == -1)
            {
                continue;
            }

            for(int Index = R; One[Index] > i; Index--)
            {
                int j = One[Index];

                if(Prefix[i - 1][0] - Prefix[l - 1][0] == Prefix[i - 1][1] - Prefix[l - 1][1] && Prefix[r][0] - Prefix[j][0] == Prefix[r][1] - Prefix[j][1])
                {
                    dp[l][r] = max(dp[l][r], f(i + 1, j - 1) + 1);
                    break;
                }
            }
        }
        else
        {
            R = Binary_One(r);

            if(R == -1)
            {
                continue;
            }

            for(int Index = R; Zero[Index] > i; Index--)
            {
                int j = Zero[Index];

                if(Prefix[i - 1][0] - Prefix[l - 1][0] == Prefix[i - 1][1] - Prefix[l - 1][1] && Prefix[r][0] - Prefix[j][0] == Prefix[r][1] - Prefix[j][1])
                {
                    dp[l][r] = max(dp[l][r], f(i + 1, j - 1) + 1);
                    break;
                }
            }
        }
    }

    return dp[l][r];
}

void Solve()
{
    cout << f(0, N - 1);
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}
