#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5001;
const int INF = 1e9;
int N;
int dp[MAXN][MAXN];
bool Visited[MAXN][MAXN];
string S;

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> S;
    N = (int)S.size();
}

int f(int l, int r)
{
    if(l < 0 || r >= N)
    {
        return 0;
    }

    if(l >= r)
    {
        return 0;
    }

    if(Visited[l][r])
    {
        return dp[l][r];
    }

    Visited[l][r] = true;

    for(int i = r; i >= l + 1; i--)
    {
        if(S[l] != S[i])
        {
            int a = f(l + 1, i - 1), b = f(i + 1, r);
            dp[l][r] = max(dp[l][r], max(a + 1, b));
        }
    }

    return dp[l][r];
}

void Solve()
{
    cout << f(0, N - 1);
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}
