#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5001;
const int INF = 1e9;
string S;
bool Visited[MAXN];

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> S;
}

void Solve()
{
    stack<int> St;

    for(int i = 0; i < S.size(); i++)
    {
        if(S[i] == '0')
        {
            if(St.empty() || S[St.top()] == '0')
            {
                St.push(i);
            }
            else
            {
                St.pop();
            }
        }
        else
        {
            St.push(i);
        }
    }

    int Ans = 0;
    int Max = 0, Min = 1e9;

    while(!St.empty())
    {
        Max = max(Max, St.top());
        Min = min(Min, St.top());
        St.pop();
    }

    cout << (Max - Min + 1) / 2;
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}
