#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5001;
const int INF = 1e9;
string S;
int N;
int dp[MAXN][MAXN];
bool Visited[MAXN][MAXN];

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> S;
    N = (int)S.size();
}

void f(int l, int r)
{
    if(l < 0 || r >= (int)S.size())
    {
        return;
    }

    if(r + 2 < N)
    {
        if(S[r + 1] != S[r + 2])
        {
            dp[l][r + 2] = max(dp[l][r + 2], dp[l][r]);
            f(l, r + 2);
        }
    }

    if(l - 2 >= 0)
    {
        if(S[l - 1] != S[l - 2])
        {
            dp[l - 2][r] = max(dp[l - 2][r], dp[l][r]);
            f(l - 2, r);
        }
    }

    if(l - 1 >= 0 && r + 1 < N)
    {
        if(S[l - 1] != S[r + 1])
        {
            dp[l - 1][r + 1] = max(dp[l - 1][r + 1], dp[l][r] + 1);
            f(l - 1, r + 1);
        }
    }
}

void Solve()
{
    for(int i = 1; i < N; i++)
    {
        if(S[i] != S[i - 1])
        {
            dp[i - 1][i] = 1;
            f(i - 1, i);
        }
    }

    cout << dp[0][N - 1];
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}
