#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

int dp[5001][5001];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    string s;

    cin >> s;

    int ans = 0;
    int n = s.size();

    memset(dp, -1, sizeof(dp));

    for (int i = 0; i < n - 1; i++)
    {
        if ((s[i] - '0' + s[i + 1] - '0') == 1)
        {
            dp[i][i + 1] = 1;
        }
    }

    for (int len = 4; len <= n; len += 2)
    {
        for (int l = 0; l <= n - len; l++)
        {
            int r = l + len - 1;

            dp[l][r] = -1;

            for (int idx1 = l + 1, idx2 = r - 1; idx1 <= idx2; idx1++, idx2--)
            {
                if ((s[idx1] - '0' + s[idx2] - '0') == 1 && dp[idx1][idx2] != -1)
                {
                    dp[l][r] = max(dp[l][r], dp[idx1][idx2] + idx1 - l);
                }
                else
                {
                    break;
                }
            }

            /*if ((s[l] - '0' + s[r] - '0') == 1 && dp[l + 1][r - 1] != -1)
            {
                dp[l][r] = dp[l + 1][r - 1] + ((s[l] - '0' + s[r] - '0') == 1);
            }*/

            for (int idx = l - 2; idx >= 0; idx -= 2)
            {
                if (dp[idx][r] != -1 && dp[l][idx] != -1)
                {
                    dp[l][r] = max(dp[l][r], dp[idx][r]);
                }
            }

            /*if ((s[l] - '0' + s[l + 1] - '0') == 1 && dp[l + 2][r] != -1)
            {
                dp[l][r] = max(dp[l][r], dp[l + 2][r]);
            }*/


            if ((s[r - 1] - '0' + s[r] - '0') == 1 && dp[l][r - 2] != -1)
            {
                dp[l][r] = max(dp[l][r], dp[l][r - 2]);
            }
        }
    }

    /*for (int l = 0; l < n; l++)
    {
        for (int r = l; r < n; r++)
        {
            cout << l << " " << r << " " << dp[l][r] << endl;
        }
    }*/

    cout << dp[0][n - 1] << endl;

    return 0;
}
