#include<bits/stdc++.h>
#define endl "\n"
using namespace std;

const long long MAX=(5e5)+5,MAX2=(1e7)+5;

long long a[MAX],p[MAX],r[MAX],n;
bool b[MAX2];
vector<long long>v[MAX];
vector<long long>primes;

void Sieve()
{
    for(long long i=2;i<=15;i++)
    {
        if(b[i]==0)
        {
            primes.push_back(i);
            for(long long j=i*i;j<=15;j+=i)
                b[j]=1;
        }
    }
}

void Sol1()
{
    unordered_set<long long>s;
    for(long long i=1;i<=n;i++)
    {
        s.insert(a[i]);
    }
    cout<<s.size()<<endl;
}

long long FindL(long long i)
{
    if(p[i]==i)
        return i;
    return p[i]=FindL(p[i]);
}

void Connect(long long i,long long j)
{
    i=FindL(i);
    j=FindL(j);
    if(i==j)
        return;
    if(r[i]<r[j])
        swap(i,j);
    p[j]=i;
    r[i]+=r[j];
}


bool IsPrime(long long x)
{
    if(x==1)
        return 0;
    for(long long i=2;i*i<=x;i++)
    {
        if(x%i==0)
            return 0;
    }
    return 1;
}

void Manage(long long x,long long ind)
{
    for(long long i=0;i<primes.size();i++)
    {
        if(primes[i]>x)
            break;
        if(x%primes[i]==0)
            v[i].push_back(ind);
        while(x%primes[i]==0)
        {
            x/=primes[i];
        }
    }
}

void Solve()
{
    cin>>n;
    Sieve();
    bool b=1;
    for(long long i=1;i<=n;i++)
    {
        cin>>a[i];
        Manage(a[i],i);
        p[i]=i;
        r[i]=1;
    }
    for(long long i=0;i<primes.size();i++)
    {
        for(long long j=1;j<v[i].size();j++)
        {
            //cout<<v[i][j]<<" "<<i<<endl;
            Connect(v[i][j],v[i][j-1]);
        }

    }

    long long ans=0;
    for(long long i=1;i<=n;i++)
    {
        if(p[i]==i)
            ans++;
    }
    cout<<ans<<endl;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    Solve();
    return 0;
}
