#include<bits/stdc++.h>
#define endl "\n"
using namespace std;

const int MAX=(5e5)+5,MAX2=(1e6)+5,MAX3=(1e9);

int a[MAX],p[MAX],r[MAX],n,idx[MAX];
bool b[MAX3];
vector<int>v[MAX];
vector<int>primes;

void Sieve()
{
    for(long long i=2;i<=MAX;i++)
    {
        if(b[i]==0)
        {
            primes.push_back(i);
            idx[i]=primes.size()-1;
            for(long long j=i*i;j<=MAX;j+=i)
            {
                if(j>MAX2-5)
                    break;
                b[j]=1;
            }
        }
    }
}

void Sol1()
{
    unordered_set<int>s;
    for(int i=1;i<=n;i++)
    {
        s.insert(a[i]);
    }
    cout<<s.size()<<endl;
}

int FindL(int i)
{
    if(p[i]==i)
        return i;
    return p[i]=FindL(p[i]);
}

void Connect(int i,int j)
{
    i=FindL(i);
    j=FindL(j);
    if(i==j)
        return;
    if(r[i]<r[j])
        swap(i,j);
    p[j]=i;
    r[i]+=r[j];
}


bool IsPrime(int x)
{
    if(x==1)
        return 0;
    for(int i=2;i*i<=x;i++)
    {
        if(x%i==0)
            return 0;
    }
    return 1;
}

void Manage(int x,int ind)
{
    if(b[x]==0)
    {
        v[idx[x]].push_back(ind);
        return;
    }
    for(int i=0;i<primes.size();i++)
    {
        if(primes[i]>x)
            break;
        if(x%primes[i]==0)
            v[i].push_back(ind);
    }
}

void Solve()
{
    cin>>n;
    Sieve();
    bool b=1;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
        Manage(a[i],i);
        p[i]=i;
        r[i]=1;
    }
    for(int i=0;i<primes.size();i++)
    {
        for(int j=1;j<v[i].size();j++)
        {
            //cout<<v[i][j]<<" "<<i<<" / ";
            Connect(v[i][j],v[i][j-1]);
        }
    }

    int ans=0;
    for(int i=1;i<=n;i++)
    {
        if(p[i]==i)
            ans++;
    }
    cout<<ans<<endl;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    Solve();
    return 0;
}
