#include<bits/stdc++.h>
#define endl "\n"
using namespace std;

const long long MAX=(1e6)+5,MAX2=(1e6)+5,MAX3=(1e9);

int a[MAX],p[MAX],r[MAX],idx[MAX],primes[MAX];
int n,sz=0;
bool b[MAX3];
vector<int>v[MAX];

void Sieve()
{
    b[1]=1;
    for(long long i=2;i*i<=MAX2;i++)
    {
        if(b[i]==0)
        {
            for(long long j=i*i;j<=MAX2;j+=i)
            {
                if(j>MAX2)
                    break;
                b[j]=1;
            }
        }
    }
    for(int i=2;i<=MAX2;i++)
    {
        if(b[i]==0)
        {
            idx[i]=sz;
            primes[sz++]=i;
        }

    }
}

int FindL(int i)
{
    if(p[i]==i)
        return i;
    return p[i]=FindL(p[i]);
}

void Connect(int i,int j)
{
    i=FindL(i);
    j=FindL(j);
    if(i==j)
        return;
    if(r[i]<r[j])
        swap(i,j);
    p[j]=i;
    r[i]+=r[j];
}

void Manage(int x,int ind)
{
    if(n>2500&&b[x]==0)
    {
        v[idx[x]].push_back(ind);
        return;
    }
    for(int i=0;i<sz;i++)
    {
        if(primes[i]>x)
            break;
        if(x%primes[i]==0)
            v[i].push_back(ind);
    }
}

void Solve()
{
    cin>>n;
    Sieve();
    bool b=1;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
        Manage(a[i],i);
        p[i]=i;
        r[i]=1;
    }
    for(int i=0;i<sz;i++)
    {
        for(int j=1;j<v[i].size();j++)
        {
            //cout<<v[i][j]<<" "<<i<<" / ";
            Connect(v[i][j],v[i][j-1]);
        }
    }

    int ans=0;
    for(int i=1;i<=n;i++)
    {
        if(p[i]==i)
            ans++;
    }
    cout<<ans<<endl;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    Solve();
    return 0;
}
