#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const ll MAXL = 5e3 + 10;

ll active[MAXL][4];
ll cur[MAXL][4];
ll ans[4];

ll l,n;

void read()
{
    cin >> l;
    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        ll x,y;
        cin >> x >> y;
        cur[x][0]++;
        cur[y + 1][0]--;
    }
    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        ll x,y;
        cin >> x >> y;
        cur[x][1]++;
        cur[y + 1][1]--;
    }
    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        ll x,y;
        cin >> x >> y;
        cur[x][2]++;
        cur[y + 1][2]--;
    }
    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        ll x,y;
        cin >> x >> y;
        cur[x][3]++;
        cur[y + 1][3]--;
    }
}

void fill_active()
{
    for(int i = 1; i <= l; i++)
    {
        active[i][0] = active[i - 1][0] + cur[i][0];
        active[i][1] = active[i - 1][1] + cur[i][1];
        active[i][2] = active[i - 1][2] + cur[i][2];
        active[i][3] = active[i - 1][3] + cur[i][3];
    }
    /**
    for(int i = 1; i <= l; i++)
    {
        for(int j = 0; j < 4; j++)
        {
            cout << active[i][j] << " ";
        }
        cout << endl;
    }
    */
}

void solve()
{
    for(int i = 1; i <= l; i++)
    {
        for(int j = 1; j <= l; j++)
        {
            ll cntN = active[j][0];
            ll cntS = active[j][1];
            ll cntE = active[i][2];
            ll cntW = active[i][3];

            ll cnt = 0;
            if(cntN > 0)
                cnt++;
            if(cntS > 0)
                cnt++;
            if(cntE > 0)
                cnt++;
            if(cntW > 0)
                cnt++;

            if(cnt == 0)
                continue;

            ans[cnt - 1] ++;
        }
    }
    cout << ans[0] << " " << ans[1] << " " << ans[2] << " " << ans[3] << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    fill_active();
    solve();

    return 0;
}
