#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const ll MAXN1 = 5e5 + 10;
const ll MAXN5 = 7510;
const ll MAXA = 1e7 + 10;

ll n;
ll ans;
ll a[MAXN1];
bool used[MAXN5];
ll g[MAXN5][MAXN5];
ll sz;

void read()
{
    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        cin >> a[i];
    }
}

void solve_prime()
{
    sort(a + 1, a + n + 1);
    ll seg = 0;
    for(int i = 2; i <= n; i++)
    {
        if(a[i] != a[i - 1])
        {
            seg++;
        }
    }
    seg++;

    cout << seg << endl;
}

ll gcd(ll a, ll b)
{
    return !b ? a : gcd(b, a % b);
}

void bruteforce()
{
    /*
    for(int i = 1; i <= n; i++)
    {
        if(used[i])
            continue;
        cout << a[i] << " ";
    }
    cout << endl << endl;
    */

   /// cout << endl;
    ll cnt = 0;
    for(int i = 1; i <= n; i++)
    {
        if(used[i])
        {
            cnt++;
            continue;
        }
        bool lampa = false;
        for(int j = 1; j <= n; j++)
        {
            if(i == j || used[j])
                continue;

            ll g = gcd(a[i], a[j]);

            if(g == 1)
                continue;

            lampa = true;
            a[++n] = a[i] * a[j];
            used[n] = false;
            used[i] = true;
            used[j] = true;
            sz--;
            bruteforce();
            a[n--] = 0;
            used[i] = false;
            used[j] = false;
            sz++;
        }
        if(!lampa)
            cnt++;
    }
    if(cnt == n)
        ans = min(ans, sz);
}

void solve_bruteforce()
{
    sz = n;
    ans = n;
    bruteforce();
    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    if(n <= 2500)
        solve_bruteforce();
    else
        solve_prime();

    return 0;
}
