#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const ll MAXN = 5001;

vector<vector<ll>>dp;
vector<vector<ll>>pref;
ll n;
bool a[MAXN];
string s;

void read()
{
    cin >> s;
    n = s.size();
}

void init()
{
    dp.resize(n + 1);
    pref.resize(n + 1);
    for(int i = 0; i <= n; i++)
    {
        dp[i].resize(n + 1, - 1);
        pref[i].resize(2, 0);
    }
}

void make()
{
    for(int i = 0; i < n; i++)
    {
        a[i + 1] = s[i] - '0';
        ///cout << a[i + 1];
    }
    ///cout << endl;
}

void fill_pref()
{
    for(int i = 1; i <= n; i++)
    {
        pref[i][0] = pref[i - 1][0];
        pref[i][1] = pref[i - 1][1];

        pref[i][a[i]]++;
        ///cout << pref[i][0] <<" " << pref[i][1] << endl;
    }
}

bool check(ll left, ll right)
{
    ll zeroes = pref[right][0] - pref[left - 1][0];
    ll ones = pref[right][1] - pref[left - 1][1];

    return zeroes == ones;
}

ll f(ll left, ll right)
{
    if(left >= right)
        return 0;

    if(dp[left][right] != -1)
        return dp[left][right];

    if(a[left] != a[right] && check(left + 1, right - 1))
        return dp[left][right] = 1 + f(left + 1, right - 1);

    dp[left][right] = 0;
    for(ll cut = left + 1; cut <= right; cut++)
    {
        if(a[left] != a[cut] && check(left + 1, cut - 1) && check(cut + 1, right))
        {
            ll cur = max(1 + f(left + 1, cut - 1), f(cut + 1, right));
            dp[left][right] = max(dp[left][right], cur);
        }
    }
    return dp[left][right];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    make();
    init();
    fill_pref();
    cout << f(1, n) << endl;
    return 0;
}
